// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.ApiManagement.SmapiModels;

namespace Microsoft.Azure.Management.ApiManagement.SmapiModels
{
    /// <summary>
    /// Subscription details.
    /// </summary>
    public partial class SubscriptionContract
    {
        private DateTime _createdDate;
        
        /// <summary>
        /// Optional. Gets or sets Subscription creation date.
        /// </summary>
        public DateTime CreatedDate
        {
            get { return this._createdDate; }
            set { this._createdDate = value; }
        }
        
        private System.DateTime? _endDate;
        
        /// <summary>
        /// Optional. Gets or sets Date when subscription was cancelled or
        /// expired.
        /// </summary>
        public System.DateTime? EndDate
        {
            get { return this._endDate; }
            set { this._endDate = value; }
        }
        
        private System.DateTime? _expirationDate;
        
        /// <summary>
        /// Optional. Gets or sets Subscription expiration date.
        /// </summary>
        public System.DateTime? ExpirationDate
        {
            get { return this._expirationDate; }
            set { this._expirationDate = value; }
        }
        
        private string _idPath;
        
        /// <summary>
        /// Optional. Gets or sets Subscription identifier path.
        /// </summary>
        public string IdPath
        {
            get { return this._idPath; }
            set { this._idPath = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets Subscription name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private System.DateTime? _notificationDate;
        
        /// <summary>
        /// Optional. Gets or sets Upcoming subscription expiration
        /// notification date.
        /// </summary>
        public System.DateTime? NotificationDate
        {
            get { return this._notificationDate; }
            set { this._notificationDate = value; }
        }
        
        private string _primaryKey;
        
        /// <summary>
        /// Optional. Gets or sets Subscription primary key.
        /// </summary>
        public string PrimaryKey
        {
            get { return this._primaryKey; }
            set { this._primaryKey = value; }
        }
        
        private string _productIdPath;
        
        /// <summary>
        /// Optional. Gets or sets Product identifier path.
        /// </summary>
        public string ProductIdPath
        {
            get { return this._productIdPath; }
            set { this._productIdPath = value; }
        }
        
        private string _secondaryKey;
        
        /// <summary>
        /// Optional. Gets or sets Subscription secondary key.
        /// </summary>
        public string SecondaryKey
        {
            get { return this._secondaryKey; }
            set { this._secondaryKey = value; }
        }
        
        private System.DateTime? _startDate;
        
        /// <summary>
        /// Optional. Gets or sets Subscription activation date.
        /// </summary>
        public System.DateTime? StartDate
        {
            get { return this._startDate; }
            set { this._startDate = value; }
        }
        
        private SubscriptionStateContract _state;
        
        /// <summary>
        /// Optional. Gets or sets Subscription state.
        /// </summary>
        public SubscriptionStateContract State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _stateComment;
        
        /// <summary>
        /// Optional. Gets or sets Subscription State Comment.
        /// </summary>
        public string StateComment
        {
            get { return this._stateComment; }
            set { this._stateComment = value; }
        }
        
        private string _userIdPath;
        
        /// <summary>
        /// Optional. Gets or sets Subscriber identifier path.
        /// </summary>
        public string UserIdPath
        {
            get { return this._userIdPath; }
            set { this._userIdPath = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SubscriptionContract class.
        /// </summary>
        public SubscriptionContract()
        {
        }
    }
}
