// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Dns Settings of a network interface
    /// </summary>
    public partial class NetworkInterfaceDnsSettings
    {
        /// <summary>
        /// Initializes a new instance of the NetworkInterfaceDnsSettings
        /// class.
        /// </summary>
        public NetworkInterfaceDnsSettings() { }

        /// <summary>
        /// Initializes a new instance of the NetworkInterfaceDnsSettings
        /// class.
        /// </summary>
        public NetworkInterfaceDnsSettings(IList<string> dnsServers = default(IList<string>), IList<string> appliedDnsServers = default(IList<string>), string internalDnsNameLabel = default(string), string internalFqdn = default(string))
        {
            DnsServers = dnsServers;
            AppliedDnsServers = appliedDnsServers;
            InternalDnsNameLabel = internalDnsNameLabel;
            InternalFqdn = internalFqdn;
        }

        /// <summary>
        /// Gets or sets list of DNS servers IP addresses
        /// </summary>
        [JsonProperty(PropertyName = "dnsServers")]
        public IList<string> DnsServers { get; set; }

        /// <summary>
        /// Gets or sets list of Applied DNS servers IP addresses
        /// </summary>
        [JsonProperty(PropertyName = "appliedDnsServers")]
        public IList<string> AppliedDnsServers { get; set; }

        /// <summary>
        /// Gets or sets the Internal DNS name
        /// </summary>
        [JsonProperty(PropertyName = "internalDnsNameLabel")]
        public string InternalDnsNameLabel { get; set; }

        /// <summary>
        /// Gets or sets full IDNS name in the form,
        /// DnsName.VnetId.ZoneId.TopleveSuffix. This is set when the NIC is
        /// associated to a VM
        /// </summary>
        [JsonProperty(PropertyName = "internalFqdn")]
        public string InternalFqdn { get; set; }

    }
}
