// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.OperationalInsights.Models;

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    /// <summary>
    /// The list workspace link targets operation response.
    /// </summary>
    public partial class WorkspaceListLinkTargetsResponse : AzureOperationResponse, IEnumerable<Account>
    {
        private IList<Account> _accounts;
        
        /// <summary>
        /// Optional. Gets or sets a list of accounts that a new workspace can
        /// attach to.
        /// </summary>
        public IList<Account> Accounts
        {
            get { return this._accounts; }
            set { this._accounts = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the WorkspaceListLinkTargetsResponse
        /// class.
        /// </summary>
        public WorkspaceListLinkTargetsResponse()
        {
            this.Accounts = new LazyList<Account>();
        }
        
        /// <summary>
        /// Gets the sequence of Accounts.
        /// </summary>
        public IEnumerator<Account> GetEnumerator()
        {
            return this.Accounts.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of Accounts.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
