// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents an Azure SQL Database Elastic Pool metric definition.
    /// </summary>
    public partial class MetricDefinition
    {
        private IList<MetricAvailability> _metricAvailabilities;
        
        /// <summary>
        /// Optional. Gets or sets the availabilities for the metric.
        /// </summary>
        public IList<MetricAvailability> MetricAvailabilities
        {
            get { return this._metricAvailabilities; }
            set { this._metricAvailabilities = value; }
        }
        
        private MetricName _name;
        
        /// <summary>
        /// Optional. Gets or sets the name for the metric
        /// </summary>
        public MetricName Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _primaryAggregationType;
        
        /// <summary>
        /// Optional. Gets or sets the aggregation type for the metric.
        /// </summary>
        public string PrimaryAggregationType
        {
            get { return this._primaryAggregationType; }
            set { this._primaryAggregationType = value; }
        }
        
        private string _unit;
        
        /// <summary>
        /// Optional. Gets or sets the units for the metric
        /// </summary>
        public string Unit
        {
            get { return this._unit; }
            set { this._unit = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MetricDefinition class.
        /// </summary>
        public MetricDefinition()
        {
            this.MetricAvailabilities = new LazyList<MetricAvailability>();
        }
    }
}
