// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Automation.Models
{
    /// <summary>
    /// The parameters supplied to the update runbook properties.
    /// </summary>
    public partial class RunbookUpdateProperties
    {
        private string _description;
        
        /// <summary>
        /// Optional. Gets or sets the description of the runbook.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private bool _logProgress;
        
        /// <summary>
        /// Optional. Gets or sets progress log option.
        /// </summary>
        public bool LogProgress
        {
            get { return this._logProgress; }
            set { this._logProgress = value; }
        }
        
        private bool _logVerbose;
        
        /// <summary>
        /// Optional. Gets or sets verbose log option.
        /// </summary>
        public bool LogVerbose
        {
            get { return this._logVerbose; }
            set { this._logVerbose = value; }
        }
        
        private string _serviceManagementTags;
        
        /// <summary>
        /// Optional. Gets or sets the service management tags of the runbook.
        /// </summary>
        public string ServiceManagementTags
        {
            get { return this._serviceManagementTags; }
            set { this._serviceManagementTags = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RunbookUpdateProperties class.
        /// </summary>
        public RunbookUpdateProperties()
        {
        }
    }
}
