// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Parameters supplied to the Replicate Virtual Machine Image operation.
    /// </summary>
    public partial class VirtualMachineVMImageReplicateParameters
    {
        private ComputeImageAttributes _computeImageAttributes;
        
        /// <summary>
        /// Required. The compute image attributes. Metadata which is required
        /// for this image to be useablein the Microsoft.Compute Provider.The
        /// combination of values provided for Offer, Sku, and Verison must be
        /// unique for a publisher.
        /// </summary>
        public ComputeImageAttributes ComputeImageAttributes
        {
            get { return this._computeImageAttributes; }
            set { this._computeImageAttributes = value; }
        }
        
        private MarketplaceImageAttributes _marketplaceImageAttributes;
        
        /// <summary>
        /// Optional. The market place image attributes.Metadata which is
        /// required for VM Marketplace sourced imagesto be useable in the
        /// Microsoft.Compute Provider.
        /// </summary>
        public MarketplaceImageAttributes MarketplaceImageAttributes
        {
            get { return this._marketplaceImageAttributes; }
            set { this._marketplaceImageAttributes = value; }
        }
        
        private IList<string> _targetLocations;
        
        /// <summary>
        /// Required. The replication target regional locations.Note: The
        /// regions in the request body are not additive. If a VM Image has
        /// already been replicated to Regions A, B, and C, and a request is
        /// made to replicate to Regions A and D, the VM Image will remain in
        /// Region A, will be replicated in Region D, and will be unreplicated
        /// from Regions B and C.
        /// </summary>
        public IList<string> TargetLocations
        {
            get { return this._targetLocations; }
            set { this._targetLocations = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineVMImageReplicateParameters class.
        /// </summary>
        public VirtualMachineVMImageReplicateParameters()
        {
            this.TargetLocations = new LazyList<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineVMImageReplicateParameters class with required
        /// arguments.
        /// </summary>
        public VirtualMachineVMImageReplicateParameters(IList<string> targetLocations, ComputeImageAttributes computeImageAttributes)
            : this()
        {
            if (targetLocations == null)
            {
                throw new ArgumentNullException("targetLocations");
            }
            if (computeImageAttributes == null)
            {
                throw new ArgumentNullException("computeImageAttributes");
            }
            this.TargetLocations = targetLocations;
            this.ComputeImageAttributes = computeImageAttributes;
        }
    }
}
