// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.Management.Monitoring.Alerts;
using Microsoft.WindowsAzure.Management.Monitoring.Alerts.Models;

namespace Microsoft.WindowsAzure.Management.Monitoring.Alerts
{
    public static partial class IncidentOperationsExtensions
    {
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.Monitoring.Alerts.IIncidentOperations.
        /// </param>
        /// <param name='incidentId'>
        /// Required. The id of the incident to retrieve.
        /// </param>
        /// <returns>
        /// The Get Incident operation response.
        /// </returns>
        public static IncidentGetResponse Get(this IIncidentOperations operations, string incidentId)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IIncidentOperations)s).GetAsync(incidentId);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.Monitoring.Alerts.IIncidentOperations.
        /// </param>
        /// <param name='incidentId'>
        /// Required. The id of the incident to retrieve.
        /// </param>
        /// <returns>
        /// The Get Incident operation response.
        /// </returns>
        public static Task<IncidentGetResponse> GetAsync(this IIncidentOperations operations, string incidentId)
        {
            return operations.GetAsync(incidentId, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.Monitoring.Alerts.IIncidentOperations.
        /// </param>
        /// <returns>
        /// The List incidents operation response.
        /// </returns>
        public static IncidentListResponse ListActiveForSubscription(this IIncidentOperations operations)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IIncidentOperations)s).ListActiveForSubscriptionAsync();
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.Monitoring.Alerts.IIncidentOperations.
        /// </param>
        /// <returns>
        /// The List incidents operation response.
        /// </returns>
        public static Task<IncidentListResponse> ListActiveForSubscriptionAsync(this IIncidentOperations operations)
        {
            return operations.ListActiveForSubscriptionAsync(CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.Monitoring.Alerts.IIncidentOperations.
        /// </param>
        /// <param name='ruleId'>
        /// Required. The rule id.
        /// </param>
        /// <param name='isActive'>
        /// Required. A boolean to retrieve only active or resolved incidents.
        /// </param>
        /// <returns>
        /// The List incidents operation response.
        /// </returns>
        public static IncidentListResponse ListForRule(this IIncidentOperations operations, string ruleId, bool isActive)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IIncidentOperations)s).ListForRuleAsync(ruleId, isActive);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.Management.Monitoring.Alerts.IIncidentOperations.
        /// </param>
        /// <param name='ruleId'>
        /// Required. The rule id.
        /// </param>
        /// <param name='isActive'>
        /// Required. A boolean to retrieve only active or resolved incidents.
        /// </param>
        /// <returns>
        /// The List incidents operation response.
        /// </returns>
        public static Task<IncidentListResponse> ListForRuleAsync(this IIncidentOperations operations, string ruleId, bool isActive)
        {
            return operations.ListForRuleAsync(ruleId, isActive, CancellationToken.None);
        }
    }
}
