// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.SiteRecovery.Models;

namespace Microsoft.WindowsAzure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The definition of a Storage object.
    /// </summary>
    public partial class AsrStorage : ServiceResourceBase
    {
        private string _fabricObjectID;
        
        /// <summary>
        /// Required. Fabric object ID.
        /// </summary>
        public string FabricObjectID
        {
            get { return this._fabricObjectID; }
            set { this._fabricObjectID = value; }
        }
        
        private string _fabricType;
        
        /// <summary>
        /// Required. Fabric object type.
        /// </summary>
        public string FabricType
        {
            get { return this._fabricType; }
            set { this._fabricType = value; }
        }
        
        private string _serverID;
        
        /// <summary>
        /// Required. Server ID.
        /// </summary>
        public string ServerID
        {
            get { return this._serverID; }
            set { this._serverID = value; }
        }
        
        private IList<StoragePool> _storagePools;
        
        /// <summary>
        /// Optional. The list of Storage Pools in a storage array.
        /// </summary>
        public IList<StoragePool> StoragePools
        {
            get { return this._storagePools; }
            set { this._storagePools = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Required. Type of the Storage.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AsrStorage class.
        /// </summary>
        public AsrStorage()
        {
            this.StoragePools = new LazyList<StoragePool>();
        }
    }
}
