// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// Describes the status of an import or export operation.
    /// </summary>
    public partial class StatusInfo
    {
        private Uri _blobUri;
        
        /// <summary>
        /// Optional. Gets the URI of the DACPAC file being used that is stored
        /// in Azure Blob Storage.  For import this is the DACPAC that is
        /// being imported.  For export this is the destination for the
        /// resultant DACPAC file.
        /// </summary>
        public Uri BlobUri
        {
            get { return this._blobUri; }
            set { this._blobUri = value; }
        }
        
        private string _databaseName;
        
        /// <summary>
        /// Optional. Gets the name of the database that is being used.  For
        /// import this is the name of the newly created database that is
        /// being imported into.  For export this is the name of the database
        /// being exported.
        /// </summary>
        public string DatabaseName
        {
            get { return this._databaseName; }
            set { this._databaseName = value; }
        }
        
        private string _errorMessage;
        
        /// <summary>
        /// Optional. Gets the error message of the request if the request
        /// failed in some way.
        /// </summary>
        public string ErrorMessage
        {
            get { return this._errorMessage; }
            set { this._errorMessage = value; }
        }
        
        private DateTime _lastModifiedTime;
        
        /// <summary>
        /// Optional. Gets the last time the operation status changed.
        /// </summary>
        public DateTime LastModifiedTime
        {
            get { return this._lastModifiedTime; }
            set { this._lastModifiedTime = value; }
        }
        
        private DateTime _queuedTime;
        
        /// <summary>
        /// Optional. Gets the time at which the import or export request was
        /// queued and the process initiated.
        /// </summary>
        public DateTime QueuedTime
        {
            get { return this._queuedTime; }
            set { this._queuedTime = value; }
        }
        
        private string _requestId;
        
        /// <summary>
        /// Optional. Gets the request ID of this import or export request.
        /// This can be used to continue to track this operation using
        /// GetStatus.
        /// </summary>
        public string RequestId
        {
            get { return this._requestId; }
            set { this._requestId = value; }
        }
        
        private string _requestType;
        
        /// <summary>
        /// Optional. Gets the type of the operation.  This can be either:
        /// Import or Export.
        /// </summary>
        public string RequestType
        {
            get { return this._requestType; }
            set { this._requestType = value; }
        }
        
        private string _serverName;
        
        /// <summary>
        /// Optional. Gets the name of the SQL Database server holding the
        /// database that the import or export operation is utilizing.
        /// </summary>
        public string ServerName
        {
            get { return this._serverName; }
            set { this._serverName = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. Gets the status of the import or export request.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the StatusInfo class.
        /// </summary>
        public StatusInfo()
        {
        }
    }
}
