// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class represents the policies associated with the volume.
    /// </summary>
    public partial class VolumePolicyInfo : CisBaseObject
    {
        private IList<string> _associatedBackupPolicies;
        
        /// <summary>
        /// Required. The backup policies associated with this volume.
        /// </summary>
        public IList<string> AssociatedBackupPolicies
        {
            get { return this._associatedBackupPolicies; }
            set { this._associatedBackupPolicies = value; }
        }
        
        private string _dataContainerId;
        
        /// <summary>
        /// Required. The data container identifier for this volume.
        /// </summary>
        public string DataContainerId
        {
            get { return this._dataContainerId; }
            set { this._dataContainerId = value; }
        }
        
        private string _dataContainerName;
        
        /// <summary>
        /// Required. The data container name for this volume.
        /// </summary>
        public string DataContainerName
        {
            get { return this._dataContainerName; }
            set { this._dataContainerName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VolumePolicyInfo class.
        /// </summary>
        public VolumePolicyInfo()
        {
            this.AssociatedBackupPolicies = new List<string>();
        }
    }
}
