// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.WebSites.Models
{
    /// <summary>
    /// Historical metric snapshot data sample.
    /// </summary>
    public partial class HistoricalUsageMetricSample
    {
        private int _count;
        
        /// <summary>
        /// Optional. The metric sample count. This value is usually 1.
        /// </summary>
        public int Count
        {
            get { return this._count; }
            set { this._count = value; }
        }
        
        private string _instanceName;
        
        /// <summary>
        /// Optional. Name of the instance for which the metric applies. If
        /// empty the metric is aggregated on all instances.
        /// </summary>
        public string InstanceName
        {
            get { return this._instanceName; }
            set { this._instanceName = value; }
        }
        
        private string _maximum;
        
        /// <summary>
        /// Optional. Maximum value recorded.
        /// </summary>
        public string Maximum
        {
            get { return this._maximum; }
            set { this._maximum = value; }
        }
        
        private string _minimum;
        
        /// <summary>
        /// Optional. Minimum value recorded.
        /// </summary>
        public string Minimum
        {
            get { return this._minimum; }
            set { this._minimum = value; }
        }
        
        private DateTime _timeCreated;
        
        /// <summary>
        /// Optional. Time the metric was taken.
        /// </summary>
        public DateTime TimeCreated
        {
            get { return this._timeCreated; }
            set { this._timeCreated = value; }
        }
        
        private string _total;
        
        /// <summary>
        /// Optional. Value of the metric sample for the time taken.
        /// </summary>
        public string Total
        {
            get { return this._total; }
            set { this._total = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the HistoricalUsageMetricSample class.
        /// </summary>
        public HistoricalUsageMetricSample()
        {
        }
    }
}
